module mod_flux

  implicit none

contains


  function fhp(u,alpha,beta) result(f)

    !-------------------- modules -------------------------!
    use mod_precision
    !------------------------------------------------------!

    implicit none

    !---------------------- in ----------------------------!
    real(pr) :: u,alpha,beta
    !------------------------------------------------------!

    !---------------------- out ---------------------------!
    real(pr) :: f
    !------------------------------------------------------!

    if (u>=beta) then
       f=2*u*beta;
    elseif (u<=-beta) then
       f=0._pr;
    else
       f=(u+beta)**2/2._pr;
    end if

    f=2._pr*alpha*beta*f;

  end function fhp

  function fhm(u,alpha,beta) result(f)

    !-------------------- modules -------------------------!
    use mod_precision
    !------------------------------------------------------!

    implicit none

    !---------------------- in ----------------------------!
    real(pr) :: u,alpha,beta
    !------------------------------------------------------!

    !---------------------- out ---------------------------!
    real(pr) :: f
    !------------------------------------------------------!

    if (u>=beta) then
       f=0._pr
    elseif (u<=-beta) then
       f=2._pr*u*beta;
    else
       f=-(u-beta)**2/2;
    end if

    f=2._pr*alpha*beta*f;

  end function fhm

  function fup(u,alpha,beta) result(f)

    !-------------------- modules -------------------------!
    use mod_precision
    !------------------------------------------------------!

    implicit none

    !---------------------- in ----------------------------!
    real(pr) :: u,alpha,beta
    !------------------------------------------------------!

    !---------------------- out ---------------------------!
    real(pr) :: f
    !------------------------------------------------------!

    if (u>=beta) then
       f=2._pr*beta/3._pr*(3._pr*u**2+beta**2);
    elseif (u<=-beta) then
       f=0._pr;
    else
       f=(u+beta)**3/3._pr;
    end if

    f=2._pr*alpha*beta*f;

  end function fup

  function fum(u,alpha,beta) result(f)

    !-------------------- modules -------------------------!
    use mod_precision
    !------------------------------------------------------!

    implicit none

    !---------------------- in ----------------------------!
    real(pr) :: u,alpha,beta
    !------------------------------------------------------!

    !---------------------- out ---------------------------!
    real(pr) :: f
    !------------------------------------------------------!

    if (u>=beta) then
       f=0._pr;
    elseif (u<=-beta) then
       f=2._pr*beta/3._pr*(3._pr*u**2+beta**2);
    else
       f=-(u-beta)**3/3._pr;
    end if

    f=2._pr*alpha*beta*f;

  end function fum




end module mod_flux
